//+------------------------------------------------------------------+
//|                                   ZigZag_NK.mq4 |
//+------------------------------------------------------------------+
/*

  11  2008 .


     .
     .

1)   .      High
    Low .     .
           "".
2)     ,     
       .      .
3)   ,    ,
      .

nen

//----+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+ 
//Version: Final, October 1, 2006                                    |
Editing:   Nikolay Kositsin  farria@mail.redcom.ru                   |
//----+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+ 
   ZigZag,    ,    
            
  .        
    ZIGZAG,            
    (  )      
!
 
//----+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
 */
#property link      "nen"
//----     
#property indicator_chart_window
//----   
#property indicator_buffers  2
//----  
#property indicator_color1 Aqua
#property indicator_color2 Aqua
//----   
#property indicator_width1 0
#property indicator_width2 0
//----    
#property indicator_style1 0
#property indicator_style2 0
//----    
extern int ExtDepth     = 12;
extern int ExtDeviation = 5;
extern int ExtBackstep  = 3;
extern int ExtMaxBar    = 300;     //    (0-)

//---- 
//----  
double LowestBuffer[],HighestBuffer[];
//----+           
int    MaxBar,time2,LASTLOWPOS,LASTHIGHPOS,LHTIME,LLTIME,size;  
//----+             
double LowestMEMORY[1],HighestMEMORY[1],LASTLOW0,LASTLOW1,LASTHIGH0,LASTHIGH1,LASTHIGHEST,LASTLOWEST;
//----+      lBar, hBar  tiZZ   
//            . 
//        .
double lBar, hBar;
datetime tiZZ;
//     Bars
int saveBars;
//+------------------------------------------------------------------+
//| ZigZag initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----       
   SetIndexBuffer(0,LowestBuffer);
   SetIndexBuffer(1,HighestBuffer);
//----      ZigZag 
   SetIndexStyle(0,DRAW_ZIGZAG);
   SetIndexStyle(1,DRAW_ZIGZAG);
//----   ,      
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
//----        
   SetIndexLabel(0,"Low" );
   SetIndexLabel(1,"High");
   IndicatorShortName("ZigZag (ExtDepth="+ExtDepth+", ExtDeviation="+ExtDeviation+", ExtBackstep="+ExtBackstep+" )");
//----     
   size=ExtBackstep+1;
//----     
   if(ArrayResize(LowestMEMORY,size)!=size)return(-1);
   if(ArrayResize(HighestMEMORY,size)!=size)return(-1);
//----  

   if (ExtMaxBar>Bars-ExtDepth || ExtMaxBar==0) MaxBar=Bars-ExtDepth; else MaxBar=ExtMaxBar;
   saveBars=0;

   return(0);
  }
//+------------------------------------------------------------------+
//|  ZigZag iteration function                                       |
//+------------------------------------------------------------------+
int start()
  {
   //----+         
   if (Bars-1<ExtDepth)return(0);
   //----+        
   int limit,iii;
   //----+      
   int    bar,back,lasthighpos,lastlowpos, j;
   double curlow,curhigh,lasthigh0,lastlow0,lasthigh1,lastlow1,val,res;

   if (Bars-saveBars-1>2)
     {
      tiZZ=0; lBar=0; hBar=0;

      ArrayInitialize(LowestBuffer,0);
      ArrayInitialize(HighestBuffer,0);

      lastlow1=-1; 
      lasthigh1=-1; 
      lastlowpos=-1; 
      lasthighpos=-1;
      if (ExtMaxBar>Bars-ExtDepth || ExtMaxBar==0) MaxBar=Bars-ExtDepth;
      limit=MaxBar;
     }
   else if (lBar<=iLow(NULL,Period(),0) && hBar>=iHigh(NULL,Period(),0) && tiZZ==iTime(NULL,Period(),0)) return(0);
   else
     {
      limit=Bars-saveBars-1;
      saveBars=Bars;
     }

   lBar=iLow(NULL,Period(),0); hBar=iHigh(NULL,Period(),0); tiZZ=iTime(NULL,Period(),0);
        
   //+---    +======+
   int Tnew=Time[limit+1];
   if (limit<=2)
    {
     if (Tnew==time2)
      {
       lastlow0=LASTLOW0;
       lasthigh0=LASTHIGH0;
       //+---
       lastlow1=LASTLOW1;
       lasthigh1=LASTHIGH1;
       //+---
       lastlowpos=iBarShift(NULL,0,LLTIME,true); 
       lasthighpos=iBarShift(NULL,0,LHTIME,true); 
       //+---   lasthighpos  lastlowpos     
       if ((lasthighpos<0)||(lastlowpos<0))
        {
         return(-1);
        }
       //+---
       LowestBuffer[lastlowpos]=LASTLOWEST;
       HighestBuffer[lasthighpos]=LASTHIGHEST;
       //+---     
       for(iii=size-1; iii>=0; iii--)
        {
         LowestBuffer[iii+limit+1]=LowestMEMORY[iii];
         HighestBuffer[iii+limit+1]=HighestMEMORY[iii];
        }
       //+---    
      } 
     else 
      {
       return(-1);  
      }
    }

   //----+ ---------- <<<     >>> -----------+  
   for(bar=limit; bar>=0; bar--)
     {
      //+---    +=========+ 
      if (bar==1)
        {
         if(((limit==1)&&(time2==Time[2]))||(limit>1))
          {
           LASTLOW0=lastlow0;
           LASTHIGH0=lasthigh0;
           //+---
           for(iii=size-1; iii>=0; iii--)
            {
             LowestMEMORY[iii]=LowestBuffer[iii+2];
             HighestMEMORY[iii]=HighestBuffer[iii+2];
            }
          }
        }
      //+---+=========================================+     
  
      //--- low
      j=iLowest(NULL,0,MODE_LOW,ExtDepth,bar);
      val=Low[j];
      if(val==lastlow0) val=0.0;
      else 
        { 
         lastlow0=val; 
         if((Low[bar]-val)>(ExtDeviation*Point))val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=LowestBuffer[j+back];
               if(res>val)LowestBuffer[j+back]=0.0; 
              }
           }
        } 
      if (j==bar) LowestBuffer[j]=val;
      //--- high
      j=iHighest(NULL,0,MODE_HIGH,ExtDepth,bar);
      val=High[j];
      if(val==lasthigh0) val=0.0;
      else 
        {
         lasthigh0=val;
         if((val-High[bar])>(ExtDeviation*Point))val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=HighestBuffer[j+back];
               if(res<val)HighestBuffer[j+back]=0.0; 
              } 
           }
        }
      if (j==bar) HighestBuffer[j]=val;
     }
    //----+     
   
   //----+ ---------- <<<     >>> -----------+  
   for(bar=limit; bar>=0; bar--)
     {
      //+---    +====+ 
      if (bar==1)
       {
        if(((limit==1)&&(time2==Time[2]))||(limit>1))
         {
          time2=Time [2];
          LASTLOW1=lastlow1;
          LASTHIGH1=lasthigh1;
          //+---
          LLTIME=Time[lastlowpos];
          LHTIME=Time[lasthighpos];
          //+---
          LASTLOWEST=LowestBuffer[lastlowpos];
          LASTHIGHEST=HighestBuffer[lasthighpos];
         }
       }
     //+---+====================================+     
     
      curlow=LowestBuffer[bar];
      curhigh=HighestBuffer[bar];
      //---
      if((curlow==0)&&(curhigh==0))continue;
      //---
      if(curhigh!=0)
        {
         if(lasthigh1>0) 
           {
            if(lasthigh1<curhigh)HighestBuffer[lasthighpos]=0;
            else HighestBuffer[bar]=0;
           }
         //---
         if(lasthigh1<curhigh || lasthigh1<0)
           {
            lasthigh1=curhigh;
            lasthighpos=bar;
           }
         lastlow1=-1;
        }
      //----
      if(curlow!=0)
        {
         if(lastlow1>0)
           {
            if(lastlow1>curlow) LowestBuffer[lastlowpos]=0;
            else LowestBuffer[bar]=0;
           }
         //---
         if((curlow<lastlow1)||(lastlow1<0))
           {
            lastlow1=curlow;
            lastlowpos=bar;
           } 
         lasthigh1=-1;
        }
     } 
   //----+     
   //+-----------------------------------------------------------------+ 
        
 //----    
return(0);
}
//+---------------------------------------------------------------------------+

